/* FileChooserDialog.c generated by valac 0.42.6, the Vala compiler
 * generated from FileChooserDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC <https://elementary.io>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1335 USA.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "pantheon-files-widgets.h"
#include <glib/gi18n-lib.h>
#include "pantheon-files-core.h"
#include <gdk/gdk.h>


#define TYPE_CUSTOM_FILE_CHOOSER_DIALOG (custom_file_chooser_dialog_get_type ())
#define CUSTOM_FILE_CHOOSER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialog))
#define CUSTOM_FILE_CHOOSER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialogClass))
#define IS_CUSTOM_FILE_CHOOSER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CUSTOM_FILE_CHOOSER_DIALOG))
#define IS_CUSTOM_FILE_CHOOSER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CUSTOM_FILE_CHOOSER_DIALOG))
#define CUSTOM_FILE_CHOOSER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialogClass))

typedef struct _CustomFileChooserDialog CustomFileChooserDialog;
typedef struct _CustomFileChooserDialogClass CustomFileChooserDialogClass;
typedef struct _CustomFileChooserDialogPrivate CustomFileChooserDialogPrivate;
enum  {
	CUSTOM_FILE_CHOOSER_DIALOG_0_PROPERTY,
	CUSTOM_FILE_CHOOSER_DIALOG_NUM_PROPERTIES
};
static GParamSpec* custom_file_chooser_dialog_properties[CUSTOM_FILE_CHOOSER_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _CustomFileChooserDialog {
	GObject parent_instance;
	CustomFileChooserDialogPrivate * priv;
};

struct _CustomFileChooserDialogClass {
	GObjectClass parent_class;
};

struct _CustomFileChooserDialogPrivate {
	GtkFileChooserDialog* chooser_dialog;
	GtkWidget* rootwidget;
	GtkBox* container_box;
	GtkButton* gtk_folder_button;
	GQueue* previous_paths;
	GQueue* next_paths;
	gboolean filters_available;
	gchar* current_path;
	gboolean is_previous;
	gboolean is_button_next;
	gboolean is_single_click;
	gboolean can_activate;
};

struct _Block1Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GSettings* chooser_settings;
	GtkButton* button_back;
	GtkButton* button_forward;
	MarlinViewChromeBasicLocationBar* location_bar;
};

struct _Block2Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkWidget* root;
};

struct _Block3Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkWidget* rootwidget;
	GtkWidget* w0;
};

struct _Block4Data {
	int _ref_count_;
	Block3Data * _data3_;
	GtkWidget* w1;
};

struct _Block5Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkWidget* w2;
};

struct _Block6Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	GtkTreeView* tv;
};

struct _Block7Data {
	int _ref_count_;
	CustomFileChooserDialog* self;
	gchar* current_filter_name;
	GtkComboBoxText* combo_box;
	gint index;
};


static gint CustomFileChooserDialog_private_offset;
static gpointer custom_file_chooser_dialog_parent_class = NULL;

GType custom_file_chooser_dialog_get_type (void) G_GNUC_CONST;
static void _g_free0_ (gpointer var);
static inline void _g_queue_free__g_free0_ (GQueue* self);
#define CUSTOM_FILE_CHOOSER_DIALOG_BUTTON_RESPONSE -6
CustomFileChooserDialog* custom_file_chooser_dialog_new (GtkFileChooserDialog* dialog);
CustomFileChooserDialog* custom_file_chooser_dialog_construct (GType object_type,
                                                               GtkFileChooserDialog* dialog);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void custom_file_chooser_dialog_assign_container_box (CustomFileChooserDialog* self);
static void custom_file_chooser_dialog_remove_gtk_widgets (CustomFileChooserDialog* self);
static void custom_file_chooser_dialog_setup_filter_box (CustomFileChooserDialog* self);
static void __lambda24_ (CustomFileChooserDialog* self);
static void ___lambda24__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda25_ (CustomFileChooserDialog* self);
static void ___lambda25__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda26_ (Block1Data* _data1_);
static void ___lambda26__gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender,
                                                           gpointer self);
static void __lambda27_ (Block1Data* _data1_);
static void ___lambda27__gtk_widget_unrealize (GtkWidget* _sender,
                                        gpointer self);
static void __lambda28_ (CustomFileChooserDialog* self,
                  const gchar* uri);
static void ___lambda28__marlin_view_chrome_locatable_path_change_request (MarlinViewChromeLocatable* _sender,
                                                                    const gchar* path,
                                                                    MarlinOpenFlag flag,
                                                                    gpointer self);
static void __lambda5_ (CustomFileChooserDialog* self,
                 GtkWidget* root);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda6_ (Block2Data* _data2_,
                 GtkWidget* w0);
static void custom_file_chooser_dialog_transform_rootwidget_container (CustomFileChooserDialog* self,
                                                                GtkWidget* rootwidget,
                                                                GtkWidget* w0);
static void ___lambda6__gfunc (gconstpointer data,
                        gpointer self);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda7_ (Block3Data* _data3_,
                 GtkWidget* w1);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda8_ (Block4Data* _data4_,
                  GtkWidget* grid);
static void ____lambda8__gfunc (gconstpointer data,
                         gpointer self);
static void custom_file_chooser_dialog_transform_w1_container (CustomFileChooserDialog* self,
                                                        GtkWidget* w1);
static void ______lambda20_ (Block4Data* _data4_,
                      GtkWidget* w5);
static void _______lambda20__gfunc (gconstpointer data,
                             gpointer self);
static void ___lambda7__gfunc (gconstpointer data,
                        gpointer self);
static void __lambda9_ (CustomFileChooserDialog* self,
                 GtkWidget* paned);
static void __lambda10_ (CustomFileChooserDialog* self,
                  GtkWidget* w2);
static void custom_file_chooser_dialog_transform_w2_container (CustomFileChooserDialog* self,
                                                        GtkWidget* w2);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda9__gfunc (gconstpointer data,
                        gpointer self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda11_ (Block5Data* _data5_,
                  GtkWidget* w3);
static void ___lambda12_ (CustomFileChooserDialog* self,
                   GtkWidget* w4);
static void __lambda13_ (CustomFileChooserDialog* self,
                  GtkWidget* w5);
static void __lambda14_ (CustomFileChooserDialog* self,
                  GtkWidget* w6);
static void ___lambda15_ (CustomFileChooserDialog* self,
                   GtkWidget* w7);
static void ____lambda15__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda14__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda13__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda12__gfunc (gconstpointer data,
                          gpointer self);
static GtkTreeView* custom_file_chooser_dialog_find_tree_view (CustomFileChooserDialog* self,
                                                        GtkWidget* browser_box);
static gboolean custom_file_chooser_dialog_on_tv_button_press_event (CustomFileChooserDialog* self,
                                                              GtkWidget* w,
                                                              GdkEventButton* event);
static gboolean _custom_file_chooser_dialog_on_tv_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                             GdkEventButton* event,
                                                                                             gpointer self);
static gboolean custom_file_chooser_dialog_on_tv_button_release_event (CustomFileChooserDialog* self,
                                                                GdkEventButton* event);
static gboolean _custom_file_chooser_dialog_on_tv_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                 GdkEventButton* event,
                                                                                                 gpointer self);
static void ___lambda11__gfunc (gconstpointer data,
                         gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda16_ (Block6Data* _data6_,
                  GtkWidget* w);
static void ___lambda17_ (Block6Data* _data6_,
                   GtkWidget* w);
static void ___lambda18_ (Block6Data* _data6_,
                   GtkWidget* w);
static void ___lambda19_ (Block6Data* _data6_,
                   GtkWidget* w);
static void ____lambda19__gfunc (gconstpointer data,
                          gpointer self);
static void ____lambda18__gfunc (gconstpointer data,
                          gpointer self);
static void ____lambda17__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda16__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda4_ (CustomFileChooserDialog* self,
                 GtkWidget* child);
static void ___lambda4__gfunc (gconstpointer data,
                        gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void ___lambda21_ (Block7Data* _data7_);
static void __lambda22_ (Block7Data* _data7_,
                  GtkFileFilter* filter);
static void ___lambda22__gfunc (gconstpointer data,
                         gpointer self);
static void ____lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                          gpointer self);
static void ___lambda23_ (Block7Data* _data7_,
                   GtkFileFilter* filter);
static void ____lambda23__gfunc (gconstpointer data,
                          gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static void custom_file_chooser_dialog_finalize (GObject * obj);

static const gchar* CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[4] = {"widget", "browse_widgets_box", "browse_files_box", "browse_header_revealer"};
static const gchar* CUSTOM_FILE_CHOOSER_DIALOG_GTK_FILTERCHOOSER_PATH[2] = {"extra_and_filters", "filter_combo_hbox"};
static const gchar* CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[3] = {"browse_files_stack", "browse_files_swin", "browse_files_tree_view"};

static inline gpointer
custom_file_chooser_dialog_get_instance_private (CustomFileChooserDialog* self)
{
	return G_STRUCT_MEMBER_P (self, CustomFileChooserDialog_private_offset);
}


static void
_g_free0_ (gpointer var)
{
#line 42 "../filechooser-module/FileChooserDialog.vala"
	var = (g_free (var), NULL);
#line 302 "FileChooserDialog.c"
}


static inline void
_g_queue_free__g_free0_ (GQueue* self)
{
#line 42 "../filechooser-module/FileChooserDialog.vala"
	g_queue_free_full (self, (GDestroyNotify) _g_free0_);
#line 311 "FileChooserDialog.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 53 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	return _data1_;
#line 322 "FileChooserDialog.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 53 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 333 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 53 "../filechooser-module/FileChooserDialog.vala"
		self = _data1_->self;
#line 53 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data1_->location_bar);
#line 53 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data1_->button_forward);
#line 53 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data1_->button_back);
#line 53 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data1_->chooser_settings);
#line 53 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (self);
#line 53 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block1Data, _data1_);
#line 349 "FileChooserDialog.c"
	}
}


static void
__lambda24_ (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GQueue* _tmp1_;
	gpointer _tmp2_;
	gchar* _tmp3_;
#line 100 "../filechooser-module/FileChooserDialog.vala"
	self->priv->is_previous = TRUE;
#line 101 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->chooser_dialog;
#line 101 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = self->priv->previous_paths;
#line 101 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = g_queue_pop_head (_tmp1_);
#line 101 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = (gchar*) _tmp2_;
#line 101 "../filechooser-module/FileChooserDialog.vala"
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp0_, _tmp3_);
#line 101 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (_tmp3_);
#line 375 "FileChooserDialog.c"
}


static void
___lambda24__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 98 "../filechooser-module/FileChooserDialog.vala"
	__lambda24_ ((CustomFileChooserDialog*) self);
#line 385 "FileChooserDialog.c"
}


static void
__lambda25_ (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GQueue* _tmp1_;
	gpointer _tmp2_;
	gchar* _tmp3_;
#line 106 "../filechooser-module/FileChooserDialog.vala"
	self->priv->is_button_next = TRUE;
#line 107 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->chooser_dialog;
#line 107 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = self->priv->next_paths;
#line 107 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = g_queue_pop_head (_tmp1_);
#line 107 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = (gchar*) _tmp2_;
#line 107 "../filechooser-module/FileChooserDialog.vala"
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp0_, _tmp3_);
#line 107 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (_tmp3_);
#line 410 "FileChooserDialog.c"
}


static void
___lambda25__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 104 "../filechooser-module/FileChooserDialog.vala"
	__lambda25_ ((CustomFileChooserDialog*) self);
#line 420 "FileChooserDialog.c"
}


static void
__lambda26_ (Block1Data* _data1_)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* previous_path = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	GtkFileChooserDialog* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_;
	gboolean _tmp16_;
	GtkButton* _tmp25_;
	GQueue* _tmp26_;
	GtkButton* _tmp27_;
	GQueue* _tmp28_;
	MarlinViewChromeBasicLocationBar* _tmp29_;
	const gchar* _tmp30_;
#line 110 "../filechooser-module/FileChooserDialog.vala"
	self = _data1_->self;
#line 111 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = self->priv->current_path;
#line 111 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = _tmp1_;
#line 111 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp0_ == NULL) {
#line 453 "FileChooserDialog.c"
		const gchar* _tmp2_;
#line 111 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = g_get_home_dir ();
#line 111 "../filechooser-module/FileChooserDialog.vala"
		_tmp0_ = _tmp2_;
#line 459 "FileChooserDialog.c"
	}
#line 111 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 111 "../filechooser-module/FileChooserDialog.vala"
	previous_path = _tmp3_;
#line 112 "../filechooser-module/FileChooserDialog.vala"
	_tmp5_ = self->priv->chooser_dialog;
#line 112 "../filechooser-module/FileChooserDialog.vala"
	_tmp6_ = gtk_file_chooser_get_current_folder_uri ((GtkFileChooser*) _tmp5_);
#line 112 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = _tmp6_;
#line 112 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp4_ == NULL) {
#line 473 "FileChooserDialog.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 112 "../filechooser-module/FileChooserDialog.vala"
		_tmp7_ = g_get_home_dir ();
#line 112 "../filechooser-module/FileChooserDialog.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 112 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (_tmp4_);
#line 112 "../filechooser-module/FileChooserDialog.vala"
		_tmp4_ = _tmp8_;
#line 484 "FileChooserDialog.c"
	}
#line 112 "../filechooser-module/FileChooserDialog.vala"
	_tmp9_ = _tmp4_;
#line 112 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = NULL;
#line 112 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (self->priv->current_path);
#line 112 "../filechooser-module/FileChooserDialog.vala"
	self->priv->current_path = _tmp9_;
#line 114 "../filechooser-module/FileChooserDialog.vala"
	_tmp11_ = previous_path;
#line 114 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp11_ == NULL) {
#line 114 "../filechooser-module/FileChooserDialog.vala"
		_tmp10_ = TRUE;
#line 500 "FileChooserDialog.c"
	} else {
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 114 "../filechooser-module/FileChooserDialog.vala"
		_tmp12_ = previous_path;
#line 114 "../filechooser-module/FileChooserDialog.vala"
		_tmp13_ = self->priv->current_path;
#line 114 "../filechooser-module/FileChooserDialog.vala"
		_tmp10_ = g_strcmp0 (_tmp12_, _tmp13_) == 0;
#line 510 "FileChooserDialog.c"
	}
#line 114 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp10_) {
#line 514 "FileChooserDialog.c"
		MarlinViewChromeBasicLocationBar* _tmp14_;
		const gchar* _tmp15_;
#line 115 "../filechooser-module/FileChooserDialog.vala"
		_tmp14_ = _data1_->location_bar;
#line 115 "../filechooser-module/FileChooserDialog.vala"
		_tmp15_ = self->priv->current_path;
#line 115 "../filechooser-module/FileChooserDialog.vala"
		marlin_view_chrome_basic_location_bar_set_display_path (_tmp14_, _tmp15_);
#line 116 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (_tmp4_);
#line 116 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (previous_path);
#line 116 "../filechooser-module/FileChooserDialog.vala"
		return;
#line 529 "FileChooserDialog.c"
	}
#line 119 "../filechooser-module/FileChooserDialog.vala"
	_tmp16_ = self->priv->is_previous;
#line 119 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp16_) {
#line 535 "FileChooserDialog.c"
		GQueue* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
#line 120 "../filechooser-module/FileChooserDialog.vala"
		_tmp17_ = self->priv->next_paths;
#line 120 "../filechooser-module/FileChooserDialog.vala"
		_tmp18_ = previous_path;
#line 120 "../filechooser-module/FileChooserDialog.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 120 "../filechooser-module/FileChooserDialog.vala"
		g_queue_push_head (_tmp17_, _tmp19_);
#line 121 "../filechooser-module/FileChooserDialog.vala"
		self->priv->is_previous = FALSE;
#line 549 "FileChooserDialog.c"
	} else {
		GQueue* _tmp20_;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		gboolean _tmp23_;
#line 123 "../filechooser-module/FileChooserDialog.vala"
		_tmp20_ = self->priv->previous_paths;
#line 123 "../filechooser-module/FileChooserDialog.vala"
		_tmp21_ = previous_path;
#line 123 "../filechooser-module/FileChooserDialog.vala"
		_tmp22_ = g_strdup (_tmp21_);
#line 123 "../filechooser-module/FileChooserDialog.vala"
		g_queue_push_head (_tmp20_, _tmp22_);
#line 124 "../filechooser-module/FileChooserDialog.vala"
		_tmp23_ = self->priv->is_button_next;
#line 124 "../filechooser-module/FileChooserDialog.vala"
		if (!_tmp23_) {
#line 567 "FileChooserDialog.c"
			GQueue* _tmp24_;
#line 125 "../filechooser-module/FileChooserDialog.vala"
			_tmp24_ = self->priv->next_paths;
#line 125 "../filechooser-module/FileChooserDialog.vala"
			g_queue_clear (_tmp24_);
#line 573 "FileChooserDialog.c"
		} else {
#line 127 "../filechooser-module/FileChooserDialog.vala"
			self->priv->is_button_next = FALSE;
#line 577 "FileChooserDialog.c"
		}
	}
#line 131 "../filechooser-module/FileChooserDialog.vala"
	_tmp25_ = _data1_->button_back;
#line 131 "../filechooser-module/FileChooserDialog.vala"
	_tmp26_ = self->priv->previous_paths;
#line 131 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, !g_queue_is_empty (_tmp26_));
#line 132 "../filechooser-module/FileChooserDialog.vala"
	_tmp27_ = _data1_->button_forward;
#line 132 "../filechooser-module/FileChooserDialog.vala"
	_tmp28_ = self->priv->next_paths;
#line 132 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp27_, !g_queue_is_empty (_tmp28_));
#line 133 "../filechooser-module/FileChooserDialog.vala"
	_tmp29_ = _data1_->location_bar;
#line 133 "../filechooser-module/FileChooserDialog.vala"
	_tmp30_ = self->priv->current_path;
#line 133 "../filechooser-module/FileChooserDialog.vala"
	marlin_view_chrome_basic_location_bar_set_display_path (_tmp29_, _tmp30_);
#line 110 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (_tmp4_);
#line 110 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (previous_path);
#line 602 "FileChooserDialog.c"
}


static void
___lambda26__gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender,
                                                      gpointer self)
{
#line 110 "../filechooser-module/FileChooserDialog.vala"
	__lambda26_ (self);
#line 612 "FileChooserDialog.c"
}


static void
__lambda27_ (Block1Data* _data1_)
{
	CustomFileChooserDialog* self;
	gchar* _tmp0_ = NULL;
	MarlinViewChromeBasicLocationBar* _tmp1_;
	gchar* _tmp2_;
	gchar* last_path = NULL;
	gchar* _tmp5_;
	GSettings* _tmp6_;
#line 135 "../filechooser-module/FileChooserDialog.vala"
	self = _data1_->self;
#line 136 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _data1_->location_bar;
#line 136 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = marlin_view_chrome_locatable_get_display_path ((MarlinViewChromeLocatable*) _tmp1_);
#line 136 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = _tmp2_;
#line 136 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp0_ == NULL) {
#line 636 "FileChooserDialog.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 136 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = g_get_home_dir ();
#line 136 "../filechooser-module/FileChooserDialog.vala"
		_tmp4_ = g_strdup (_tmp3_);
#line 136 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (_tmp0_);
#line 136 "../filechooser-module/FileChooserDialog.vala"
		_tmp0_ = _tmp4_;
#line 647 "FileChooserDialog.c"
	}
#line 136 "../filechooser-module/FileChooserDialog.vala"
	_tmp5_ = g_strdup (_tmp0_);
#line 136 "../filechooser-module/FileChooserDialog.vala"
	last_path = _tmp5_;
#line 137 "../filechooser-module/FileChooserDialog.vala"
	_tmp6_ = _data1_->chooser_settings;
#line 137 "../filechooser-module/FileChooserDialog.vala"
	g_settings_set_string (_tmp6_, "last-folder-uri", last_path);
#line 135 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (last_path);
#line 135 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (_tmp0_);
#line 661 "FileChooserDialog.c"
}


static void
___lambda27__gtk_widget_unrealize (GtkWidget* _sender,
                                   gpointer self)
{
#line 135 "../filechooser-module/FileChooserDialog.vala"
	__lambda27_ (self);
#line 671 "FileChooserDialog.c"
}


static void
__lambda28_ (CustomFileChooserDialog* self,
             const gchar* uri)
{
	GtkFileChooserDialog* _tmp1_;
#line 140 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (uri != NULL);
#line 141 "../filechooser-module/FileChooserDialog.vala"
	if (uri != NULL) {
#line 684 "FileChooserDialog.c"
		GtkFileChooserDialog* _tmp0_;
#line 142 "../filechooser-module/FileChooserDialog.vala"
		_tmp0_ = self->priv->chooser_dialog;
#line 142 "../filechooser-module/FileChooserDialog.vala"
		gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp0_, uri);
#line 690 "FileChooserDialog.c"
	}
#line 145 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = self->priv->chooser_dialog;
#line 145 "../filechooser-module/FileChooserDialog.vala"
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp1_, FALSE);
#line 696 "FileChooserDialog.c"
}


static void
___lambda28__marlin_view_chrome_locatable_path_change_request (MarlinViewChromeLocatable* _sender,
                                                               const gchar* path,
                                                               MarlinOpenFlag flag,
                                                               gpointer self)
{
#line 140 "../filechooser-module/FileChooserDialog.vala"
	__lambda28_ ((CustomFileChooserDialog*) self, path);
#line 708 "FileChooserDialog.c"
}


CustomFileChooserDialog*
custom_file_chooser_dialog_construct (GType object_type,
                                      GtkFileChooserDialog* dialog)
{
	CustomFileChooserDialog * self = NULL;
	Block1Data* _data1_;
	GQueue* _tmp0_;
	GQueue* _tmp1_;
	GtkFileChooserDialog* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	GSettings* settings = NULL;
	GSettings* _tmp5_;
	GSettings* _tmp6_;
	GSettings* _tmp7_;
	GtkHeaderBar* header_bar = NULL;
	GtkHeaderBar* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	MarlinViewChromeBasicLocationBar* _tmp15_;
	MarlinViewChromeBasicLocationBar* _tmp16_;
	GtkHeaderBar* _tmp17_;
	GtkButton* _tmp18_;
	GtkHeaderBar* _tmp19_;
	GtkButton* _tmp20_;
	GtkHeaderBar* _tmp21_;
	MarlinViewChromeBasicLocationBar* _tmp22_;
	gboolean _tmp23_ = FALSE;
	GtkButton* _tmp24_;
	GtkFileChooserDialog* _tmp34_;
	GtkHeaderBar* _tmp35_;
	GtkFileChooserDialog* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkFileChooserDialog* _tmp39_;
	GtkFileChooserDialog* _tmp40_;
	MarlinViewChromeBasicLocationBar* _tmp41_;
	gchar* last_folder = NULL;
	GSettings* _tmp42_;
	gchar* _tmp43_;
	const gchar* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	GtkFileChooserDialog* _tmp49_;
	const gchar* _tmp50_;
#line 53 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (dialog != NULL, NULL);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_data1_->_ref_count_ = 1;
#line 53 "../filechooser-module/FileChooserDialog.vala"
	self = (CustomFileChooserDialog*) g_object_new (object_type, NULL);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_data1_->self = g_object_ref (self);
#line 54 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = g_queue_new ();
#line 54 "../filechooser-module/FileChooserDialog.vala"
	(self->priv->previous_paths == NULL) ? NULL : (self->priv->previous_paths = (_g_queue_free__g_free0_ (self->priv->previous_paths), NULL));
#line 54 "../filechooser-module/FileChooserDialog.vala"
	self->priv->previous_paths = _tmp0_;
#line 55 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = g_queue_new ();
#line 55 "../filechooser-module/FileChooserDialog.vala"
	(self->priv->next_paths == NULL) ? NULL : (self->priv->next_paths = (_g_queue_free__g_free0_ (self->priv->next_paths), NULL));
#line 55 "../filechooser-module/FileChooserDialog.vala"
	self->priv->next_paths = _tmp1_;
#line 57 "../filechooser-module/FileChooserDialog.vala"
	self->priv->chooser_dialog = dialog;
#line 58 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = self->priv->chooser_dialog;
#line 58 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp2_, TRUE);
#line 59 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = self->priv->chooser_dialog;
#line 59 "../filechooser-module/FileChooserDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) _tmp3_, FALSE);
#line 61 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = self->priv->chooser_dialog;
#line 61 "../filechooser-module/FileChooserDialog.vala"
	gtk_file_chooser_set_local_only ((GtkFileChooser*) _tmp4_, TRUE);
#line 63 "../filechooser-module/FileChooserDialog.vala"
	_tmp5_ = g_settings_new ("io.elementary.files.preferences");
#line 63 "../filechooser-module/FileChooserDialog.vala"
	settings = _tmp5_;
#line 64 "../filechooser-module/FileChooserDialog.vala"
	_tmp6_ = settings;
#line 64 "../filechooser-module/FileChooserDialog.vala"
	self->priv->is_single_click = g_settings_get_boolean (_tmp6_, "single-click");
#line 66 "../filechooser-module/FileChooserDialog.vala"
	_tmp7_ = g_settings_new ("io.elementary.files.file-chooser");
#line 66 "../filechooser-module/FileChooserDialog.vala"
	_data1_->chooser_settings = _tmp7_;
#line 68 "../filechooser-module/FileChooserDialog.vala"
	custom_file_chooser_dialog_assign_container_box (self);
#line 69 "../filechooser-module/FileChooserDialog.vala"
	custom_file_chooser_dialog_remove_gtk_widgets (self);
#line 70 "../filechooser-module/FileChooserDialog.vala"
	custom_file_chooser_dialog_setup_filter_box (self);
#line 72 "../filechooser-module/FileChooserDialog.vala"
	_tmp8_ = (GtkHeaderBar*) gtk_header_bar_new ();
#line 72 "../filechooser-module/FileChooserDialog.vala"
	g_object_ref_sink (_tmp8_);
#line 72 "../filechooser-module/FileChooserDialog.vala"
	header_bar = _tmp8_;
#line 74 "../filechooser-module/FileChooserDialog.vala"
	_tmp9_ = (GtkButton*) gtk_button_new_from_icon_name ("go-previous-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 74 "../filechooser-module/FileChooserDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 74 "../filechooser-module/FileChooserDialog.vala"
	_data1_->button_back = _tmp9_;
#line 75 "../filechooser-module/FileChooserDialog.vala"
	_tmp10_ = _data1_->button_back;
#line 75 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, _ ("Previous"));
#line 76 "../filechooser-module/FileChooserDialog.vala"
	_tmp11_ = _data1_->button_back;
#line 76 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 78 "../filechooser-module/FileChooserDialog.vala"
	_tmp12_ = (GtkButton*) gtk_button_new_from_icon_name ("go-next-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 78 "../filechooser-module/FileChooserDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 78 "../filechooser-module/FileChooserDialog.vala"
	_data1_->button_forward = _tmp12_;
#line 79 "../filechooser-module/FileChooserDialog.vala"
	_tmp13_ = _data1_->button_forward;
#line 79 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Next"));
#line 80 "../filechooser-module/FileChooserDialog.vala"
	_tmp14_ = _data1_->button_forward;
#line 80 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, FALSE);
#line 82 "../filechooser-module/FileChooserDialog.vala"
	_tmp15_ = marlin_view_chrome_basic_location_bar_new (NULL);
#line 82 "../filechooser-module/FileChooserDialog.vala"
	g_object_ref_sink (_tmp15_);
#line 82 "../filechooser-module/FileChooserDialog.vala"
	_data1_->location_bar = _tmp15_;
#line 83 "../filechooser-module/FileChooserDialog.vala"
	_tmp16_ = _data1_->location_bar;
#line 83 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
#line 85 "../filechooser-module/FileChooserDialog.vala"
	_tmp17_ = header_bar;
#line 85 "../filechooser-module/FileChooserDialog.vala"
	_tmp18_ = _data1_->button_back;
#line 85 "../filechooser-module/FileChooserDialog.vala"
	gtk_header_bar_pack_start (_tmp17_, (GtkWidget*) _tmp18_);
#line 86 "../filechooser-module/FileChooserDialog.vala"
	_tmp19_ = header_bar;
#line 86 "../filechooser-module/FileChooserDialog.vala"
	_tmp20_ = _data1_->button_forward;
#line 86 "../filechooser-module/FileChooserDialog.vala"
	gtk_header_bar_pack_start (_tmp19_, (GtkWidget*) _tmp20_);
#line 87 "../filechooser-module/FileChooserDialog.vala"
	_tmp21_ = header_bar;
#line 87 "../filechooser-module/FileChooserDialog.vala"
	_tmp22_ = _data1_->location_bar;
#line 87 "../filechooser-module/FileChooserDialog.vala"
	gtk_header_bar_pack_start (_tmp21_, (GtkWidget*) _tmp22_);
#line 88 "../filechooser-module/FileChooserDialog.vala"
	_tmp24_ = self->priv->gtk_folder_button;
#line 88 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp24_ != NULL) {
#line 881 "FileChooserDialog.c"
		GtkFileChooserDialog* _tmp25_;
#line 88 "../filechooser-module/FileChooserDialog.vala"
		_tmp25_ = self->priv->chooser_dialog;
#line 88 "../filechooser-module/FileChooserDialog.vala"
		_tmp23_ = gtk_file_chooser_get_action ((GtkFileChooser*) _tmp25_) != GTK_FILE_CHOOSER_ACTION_OPEN;
#line 887 "FileChooserDialog.c"
	} else {
#line 88 "../filechooser-module/FileChooserDialog.vala"
		_tmp23_ = FALSE;
#line 891 "FileChooserDialog.c"
	}
#line 88 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp23_) {
#line 895 "FileChooserDialog.c"
		GtkButton* _tmp26_;
		GtkImage* _tmp27_;
		GtkImage* _tmp28_;
		GtkButton* _tmp29_;
		GtkContainer* _tmp30_;
		GtkButton* _tmp31_;
		GtkHeaderBar* _tmp32_;
		GtkButton* _tmp33_;
#line 89 "../filechooser-module/FileChooserDialog.vala"
		_tmp26_ = self->priv->gtk_folder_button;
#line 89 "../filechooser-module/FileChooserDialog.vala"
		_tmp27_ = (GtkImage*) gtk_image_new_from_icon_name ("folder-new", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 89 "../filechooser-module/FileChooserDialog.vala"
		g_object_ref_sink (_tmp27_);
#line 89 "../filechooser-module/FileChooserDialog.vala"
		_tmp28_ = _tmp27_;
#line 89 "../filechooser-module/FileChooserDialog.vala"
		gtk_button_set_image (_tmp26_, (GtkWidget*) _tmp28_);
#line 89 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_tmp28_);
#line 90 "../filechooser-module/FileChooserDialog.vala"
		_tmp29_ = self->priv->gtk_folder_button;
#line 90 "../filechooser-module/FileChooserDialog.vala"
		_tmp30_ = gtk_widget_get_parent ((GtkWidget*) _tmp29_);
#line 90 "../filechooser-module/FileChooserDialog.vala"
		_tmp31_ = self->priv->gtk_folder_button;
#line 90 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_container_get_type (), GtkContainer), (GtkWidget*) _tmp31_);
#line 91 "../filechooser-module/FileChooserDialog.vala"
		_tmp32_ = header_bar;
#line 91 "../filechooser-module/FileChooserDialog.vala"
		_tmp33_ = self->priv->gtk_folder_button;
#line 91 "../filechooser-module/FileChooserDialog.vala"
		gtk_header_bar_pack_end (_tmp32_, (GtkWidget*) _tmp33_);
#line 930 "FileChooserDialog.c"
	}
#line 94 "../filechooser-module/FileChooserDialog.vala"
	_tmp34_ = self->priv->chooser_dialog;
#line 94 "../filechooser-module/FileChooserDialog.vala"
	_tmp35_ = header_bar;
#line 94 "../filechooser-module/FileChooserDialog.vala"
	gtk_window_set_titlebar ((GtkWindow*) _tmp34_, (GtkWidget*) _tmp35_);
#line 95 "../filechooser-module/FileChooserDialog.vala"
	_tmp36_ = self->priv->chooser_dialog;
#line 95 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp36_);
#line 98 "../filechooser-module/FileChooserDialog.vala"
	_tmp37_ = _data1_->button_back;
#line 98 "../filechooser-module/FileChooserDialog.vala"
	g_signal_connect_object (_tmp37_, "clicked", (GCallback) ___lambda24__gtk_button_clicked, self, 0);
#line 104 "../filechooser-module/FileChooserDialog.vala"
	_tmp38_ = _data1_->button_forward;
#line 104 "../filechooser-module/FileChooserDialog.vala"
	g_signal_connect_object (_tmp38_, "clicked", (GCallback) ___lambda25__gtk_button_clicked, self, 0);
#line 110 "../filechooser-module/FileChooserDialog.vala"
	_tmp39_ = self->priv->chooser_dialog;
#line 110 "../filechooser-module/FileChooserDialog.vala"
	g_signal_connect_data ((GtkFileChooser*) _tmp39_, "current-folder-changed", (GCallback) ___lambda26__gtk_file_chooser_current_folder_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 135 "../filechooser-module/FileChooserDialog.vala"
	_tmp40_ = self->priv->chooser_dialog;
#line 135 "../filechooser-module/FileChooserDialog.vala"
	g_signal_connect_data ((GtkWidget*) _tmp40_, "unrealize", (GCallback) ___lambda27__gtk_widget_unrealize, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
#line 140 "../filechooser-module/FileChooserDialog.vala"
	_tmp41_ = _data1_->location_bar;
#line 140 "../filechooser-module/FileChooserDialog.vala"
	g_signal_connect_object ((MarlinViewChromeLocatable*) _tmp41_, "path-change-request", (GCallback) ___lambda28__marlin_view_chrome_locatable_path_change_request, self, 0);
#line 152 "../filechooser-module/FileChooserDialog.vala"
	_tmp42_ = _data1_->chooser_settings;
#line 152 "../filechooser-module/FileChooserDialog.vala"
	_tmp43_ = g_settings_get_string (_tmp42_, "last-folder-uri");
#line 152 "../filechooser-module/FileChooserDialog.vala"
	last_folder = _tmp43_;
#line 153 "../filechooser-module/FileChooserDialog.vala"
	_tmp44_ = last_folder;
#line 153 "../filechooser-module/FileChooserDialog.vala"
	_tmp45_ = strlen (_tmp44_);
#line 153 "../filechooser-module/FileChooserDialog.vala"
	_tmp46_ = _tmp45_;
#line 153 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp46_ < 1) {
#line 976 "FileChooserDialog.c"
		const gchar* _tmp47_;
		gchar* _tmp48_;
#line 154 "../filechooser-module/FileChooserDialog.vala"
		_tmp47_ = g_get_home_dir ();
#line 154 "../filechooser-module/FileChooserDialog.vala"
		_tmp48_ = g_strdup (_tmp47_);
#line 154 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (last_folder);
#line 154 "../filechooser-module/FileChooserDialog.vala"
		last_folder = _tmp48_;
#line 987 "FileChooserDialog.c"
	}
#line 157 "../filechooser-module/FileChooserDialog.vala"
	_tmp49_ = self->priv->chooser_dialog;
#line 157 "../filechooser-module/FileChooserDialog.vala"
	_tmp50_ = last_folder;
#line 157 "../filechooser-module/FileChooserDialog.vala"
	gtk_file_chooser_set_current_folder_uri ((GtkFileChooser*) _tmp49_, _tmp50_);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (last_folder);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (header_bar);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (settings);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	block1_data_unref (_data1_);
#line 53 "../filechooser-module/FileChooserDialog.vala"
	_data1_ = NULL;
#line 53 "../filechooser-module/FileChooserDialog.vala"
	return self;
#line 1007 "FileChooserDialog.c"
}


CustomFileChooserDialog*
custom_file_chooser_dialog_new (GtkFileChooserDialog* dialog)
{
#line 53 "../filechooser-module/FileChooserDialog.vala"
	return custom_file_chooser_dialog_construct (TYPE_CUSTOM_FILE_CHOOSER_DIALOG, dialog);
#line 1016 "FileChooserDialog.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 166 "../filechooser-module/FileChooserDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 1025 "FileChooserDialog.c"
}


static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 166 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	return _data2_;
#line 1036 "FileChooserDialog.c"
}


static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 166 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1047 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 166 "../filechooser-module/FileChooserDialog.vala"
		self = _data2_->self;
#line 166 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data2_->root);
#line 166 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (self);
#line 166 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block2Data, _data2_);
#line 1057 "FileChooserDialog.c"
	}
}


static void
__lambda6_ (Block2Data* _data2_,
            GtkWidget* w0)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 167 "../filechooser-module/FileChooserDialog.vala"
	self = _data2_->self;
#line 167 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w0 != NULL);
#line 168 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w0);
#line 168 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[0];
#line 168 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 1079 "FileChooserDialog.c"
		GtkContainer* chooserwidget = NULL;
		GtkContainer* _tmp2_;
		GtkContainer* _tmp3_;
		GtkBox* root_box = NULL;
		GtkBox* _tmp4_;
		GtkBox* _tmp5_;
		GtkSeparator* _tmp6_;
		GtkSeparator* _tmp7_;
		GtkBox* _tmp8_;
		GtkContainer* _tmp9_;
		GtkFileChooserDialog* _tmp10_;
		GtkWidget* _tmp11_;
		GtkBox* _tmp15_;
		GtkContainer* _tmp16_;
		GtkWidget* _tmp17_;
		GtkWidget* _tmp18_;
#line 170 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (w0, gtk_container_get_type ()) ? ((GtkContainer*) w0) : NULL);
#line 170 "../filechooser-module/FileChooserDialog.vala"
		chooserwidget = _tmp2_;
#line 171 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = chooserwidget;
#line 171 "../filechooser-module/FileChooserDialog.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 173 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data2_->root, gtk_container_get_type ()) ? ((GtkContainer*) _data2_->root) : NULL, w0);
#line 174 "../filechooser-module/FileChooserDialog.vala"
		_tmp4_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 174 "../filechooser-module/FileChooserDialog.vala"
		g_object_ref_sink (_tmp4_);
#line 174 "../filechooser-module/FileChooserDialog.vala"
		root_box = _tmp4_;
#line 175 "../filechooser-module/FileChooserDialog.vala"
		_tmp5_ = root_box;
#line 175 "../filechooser-module/FileChooserDialog.vala"
		_tmp6_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 175 "../filechooser-module/FileChooserDialog.vala"
		g_object_ref_sink (_tmp6_);
#line 175 "../filechooser-module/FileChooserDialog.vala"
		_tmp7_ = _tmp6_;
#line 175 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp7_);
#line 175 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_tmp7_);
#line 176 "../filechooser-module/FileChooserDialog.vala"
		_tmp8_ = root_box;
#line 176 "../filechooser-module/FileChooserDialog.vala"
		_tmp9_ = chooserwidget;
#line 176 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 178 "../filechooser-module/FileChooserDialog.vala"
		_tmp10_ = self->priv->chooser_dialog;
#line 178 "../filechooser-module/FileChooserDialog.vala"
		_tmp11_ = gtk_file_chooser_get_extra_widget ((GtkFileChooser*) _tmp10_);
#line 178 "../filechooser-module/FileChooserDialog.vala"
		if (_tmp11_ == NULL) {
#line 1136 "FileChooserDialog.c"
			GtkBox* _tmp12_;
			GtkSeparator* _tmp13_;
			GtkSeparator* _tmp14_;
#line 179 "../filechooser-module/FileChooserDialog.vala"
			_tmp12_ = root_box;
#line 179 "../filechooser-module/FileChooserDialog.vala"
			_tmp13_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 179 "../filechooser-module/FileChooserDialog.vala"
			g_object_ref_sink (_tmp13_);
#line 179 "../filechooser-module/FileChooserDialog.vala"
			_tmp14_ = _tmp13_;
#line 179 "../filechooser-module/FileChooserDialog.vala"
			gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp14_);
#line 179 "../filechooser-module/FileChooserDialog.vala"
			_g_object_unref0 (_tmp14_);
#line 1152 "FileChooserDialog.c"
		}
#line 182 "../filechooser-module/FileChooserDialog.vala"
		_tmp15_ = root_box;
#line 182 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_TYPE (_data2_->root, gtk_container_get_type ()) ? ((GtkContainer*) _data2_->root) : NULL, (GtkWidget*) _tmp15_);
#line 183 "../filechooser-module/FileChooserDialog.vala"
		_tmp16_ = chooserwidget;
#line 183 "../filechooser-module/FileChooserDialog.vala"
		self->priv->rootwidget = (GtkWidget*) _tmp16_;
#line 184 "../filechooser-module/FileChooserDialog.vala"
		self->priv->rootwidget = w0;
#line 185 "../filechooser-module/FileChooserDialog.vala"
		_tmp17_ = self->priv->rootwidget;
#line 185 "../filechooser-module/FileChooserDialog.vala"
		gtk_widget_set_can_focus (_tmp17_, TRUE);
#line 186 "../filechooser-module/FileChooserDialog.vala"
		_tmp18_ = self->priv->rootwidget;
#line 186 "../filechooser-module/FileChooserDialog.vala"
		custom_file_chooser_dialog_transform_rootwidget_container (self, _tmp18_, w0);
#line 168 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (root_box);
#line 168 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (chooserwidget);
#line 1176 "FileChooserDialog.c"
	}
}


static void
___lambda6__gfunc (gconstpointer data,
                   gpointer self)
{
#line 167 "../filechooser-module/FileChooserDialog.vala"
	__lambda6_ (self, (GtkWidget*) data);
#line 1187 "FileChooserDialog.c"
}


static void
__lambda5_ (CustomFileChooserDialog* self,
            GtkWidget* root)
{
	Block2Data* _data2_;
	GtkWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 166 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (root != NULL);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_data2_->_ref_count_ = 1;
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_data2_->self = g_object_ref (self);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = _g_object_ref0 (root);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (_data2_->root);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_data2_->root = _tmp0_;
#line 167 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data2_->root, gtk_container_get_type ()) ? ((GtkContainer*) _data2_->root) : NULL);
#line 167 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = _tmp1_;
#line 167 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp2_, ___lambda6__gfunc, _data2_);
#line 167 "../filechooser-module/FileChooserDialog.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 166 "../filechooser-module/FileChooserDialog.vala"
	block2_data_unref (_data2_);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_data2_ = NULL;
#line 1225 "FileChooserDialog.c"
}


static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
#line 166 "../filechooser-module/FileChooserDialog.vala"
	__lambda5_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1235 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_remove_gtk_widgets (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 165 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (self != NULL);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->chooser_dialog;
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = _tmp1_;
#line 166 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp2_, ___lambda5__gfunc, self);
#line 166 "../filechooser-module/FileChooserDialog.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 1257 "FileChooserDialog.c"
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 192 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	return _data3_;
#line 1268 "FileChooserDialog.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 192 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1279 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 192 "../filechooser-module/FileChooserDialog.vala"
		self = _data3_->self;
#line 192 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data3_->rootwidget);
#line 192 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data3_->w0);
#line 192 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (self);
#line 192 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block3Data, _data3_);
#line 1291 "FileChooserDialog.c"
	}
}


static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 193 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	return _data4_;
#line 1303 "FileChooserDialog.c"
}


static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 193 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1314 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 193 "../filechooser-module/FileChooserDialog.vala"
		self = _data4_->_data3_->self;
#line 193 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data4_->w1);
#line 193 "../filechooser-module/FileChooserDialog.vala"
		block3_data_unref (_data4_->_data3_);
#line 193 "../filechooser-module/FileChooserDialog.vala"
		_data4_->_data3_ = NULL;
#line 193 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block4Data, _data4_);
#line 1326 "FileChooserDialog.c"
	}
}


static void
___lambda8_ (Block4Data* _data4_,
             GtkWidget* grid)
{
	Block3Data* _data3_;
	CustomFileChooserDialog* self;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
#line 198 "../filechooser-module/FileChooserDialog.vala"
	_data3_ = _data4_->_data3_;
#line 198 "../filechooser-module/FileChooserDialog.vala"
	self = _data3_->self;
#line 198 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (grid != NULL);
#line 199 "../filechooser-module/FileChooserDialog.vala"
	g_object_ref ((GObject*) grid);
#line 200 "../filechooser-module/FileChooserDialog.vala"
	g_object_set (grid, "margin", 0, NULL);
#line 201 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_valign (grid, GTK_ALIGN_CENTER);
#line 202 "../filechooser-module/FileChooserDialog.vala"
	gtk_container_set_border_width (G_TYPE_CHECK_INSTANCE_CAST (grid, gtk_container_get_type (), GtkContainer), (guint) 0);
#line 203 "../filechooser-module/FileChooserDialog.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL, grid);
#line 204 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->container_box;
#line 204 "../filechooser-module/FileChooserDialog.vala"
	gtk_box_pack_start (_tmp0_, grid, TRUE, TRUE, (guint) 0);
#line 205 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = self->priv->container_box;
#line 205 "../filechooser-module/FileChooserDialog.vala"
	gtk_button_box_set_child_secondary (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_button_box_get_type (), GtkButtonBox), grid, TRUE);
#line 206 "../filechooser-module/FileChooserDialog.vala"
	g_object_unref ((GObject*) grid);
#line 1365 "FileChooserDialog.c"
}


static void
____lambda8__gfunc (gconstpointer data,
                    gpointer self)
{
#line 198 "../filechooser-module/FileChooserDialog.vala"
	___lambda8_ (self, (GtkWidget*) data);
#line 1375 "FileChooserDialog.c"
}


static void
______lambda20_ (Block4Data* _data4_,
                 GtkWidget* w5)
{
	Block3Data* _data3_;
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 219 "../filechooser-module/FileChooserDialog.vala"
	_data3_ = _data4_->_data3_;
#line 219 "../filechooser-module/FileChooserDialog.vala"
	self = _data3_->self;
#line 219 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w5 != NULL);
#line 220 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w5);
#line 220 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_FILTERCHOOSER_PATH[1];
#line 220 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 221 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL, w5);
#line 1401 "FileChooserDialog.c"
	}
}


static void
_______lambda20__gfunc (gconstpointer data,
                        gpointer self)
{
#line 219 "../filechooser-module/FileChooserDialog.vala"
	______lambda20_ (self, (GtkWidget*) data);
#line 1412 "FileChooserDialog.c"
}


static void
__lambda7_ (Block3Data* _data3_,
            GtkWidget* w1)
{
	CustomFileChooserDialog* self;
	Block4Data* _data4_;
	GtkWidget* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 193 "../filechooser-module/FileChooserDialog.vala"
	self = _data3_->self;
#line 193 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w1 != NULL);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_data4_->_ref_count_ = 1;
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_data4_->_data3_ = block3_data_ref (_data3_);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = _g_object_ref0 (w1);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (_data4_->w1);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_data4_->w1 = _tmp0_;
#line 194 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = gtk_widget_get_name (_data4_->w1);
#line 194 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = _tmp2_;
#line 194 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp3_, "GtkBox") == 0) {
#line 1448 "FileChooserDialog.c"
		const gchar* _tmp4_;
		const gchar* _tmp5_;
#line 194 "../filechooser-module/FileChooserDialog.vala"
		_tmp4_ = gtk_buildable_get_name ((GtkBuildable*) _data4_->w1);
#line 194 "../filechooser-module/FileChooserDialog.vala"
		_tmp5_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[1];
#line 194 "../filechooser-module/FileChooserDialog.vala"
		_tmp1_ = g_strcmp0 (_tmp4_, _tmp5_) != 0;
#line 1457 "FileChooserDialog.c"
	} else {
#line 194 "../filechooser-module/FileChooserDialog.vala"
		_tmp1_ = FALSE;
#line 1461 "FileChooserDialog.c"
	}
#line 194 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp1_) {
#line 1465 "FileChooserDialog.c"
		GList* _tmp6_;
		GList* _tmp7_;
		GtkBox* _tmp8_;
#line 195 "../filechooser-module/FileChooserDialog.vala"
		g_object_ref ((GObject*) _data4_->w1);
#line 196 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data3_->rootwidget, gtk_container_get_type ()) ? ((GtkContainer*) _data3_->rootwidget) : NULL, _data4_->w1);
#line 198 "../filechooser-module/FileChooserDialog.vala"
		_tmp6_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL);
#line 198 "../filechooser-module/FileChooserDialog.vala"
		_tmp7_ = _tmp6_;
#line 198 "../filechooser-module/FileChooserDialog.vala"
		g_list_foreach (_tmp7_, ____lambda8__gfunc, _data4_);
#line 198 "../filechooser-module/FileChooserDialog.vala"
		(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 209 "../filechooser-module/FileChooserDialog.vala"
		g_object_unref ((GObject*) _data4_->w1);
#line 210 "../filechooser-module/FileChooserDialog.vala"
		_tmp8_ = self->priv->container_box;
#line 210 "../filechooser-module/FileChooserDialog.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp8_);
#line 1487 "FileChooserDialog.c"
	} else {
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 211 "../filechooser-module/FileChooserDialog.vala"
		_tmp9_ = gtk_buildable_get_name ((GtkBuildable*) _data4_->w1);
#line 211 "../filechooser-module/FileChooserDialog.vala"
		_tmp10_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[1];
#line 211 "../filechooser-module/FileChooserDialog.vala"
		if (g_strcmp0 (_tmp9_, _tmp10_) == 0) {
#line 212 "../filechooser-module/FileChooserDialog.vala"
			custom_file_chooser_dialog_transform_w1_container (self, _data4_->w1);
#line 1499 "FileChooserDialog.c"
		} else {
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 214 "../filechooser-module/FileChooserDialog.vala"
			_tmp11_ = gtk_buildable_get_name ((GtkBuildable*) _data4_->w1);
#line 214 "../filechooser-module/FileChooserDialog.vala"
			_tmp12_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_FILTERCHOOSER_PATH[0];
#line 214 "../filechooser-module/FileChooserDialog.vala"
			if (g_strcmp0 (_tmp11_, _tmp12_) == 0) {
#line 1509 "FileChooserDialog.c"
				GtkFileChooserDialog* _tmp13_;
				GtkWidget* _tmp14_;
#line 216 "../filechooser-module/FileChooserDialog.vala"
				_tmp13_ = self->priv->chooser_dialog;
#line 216 "../filechooser-module/FileChooserDialog.vala"
				_tmp14_ = gtk_file_chooser_get_extra_widget ((GtkFileChooser*) _tmp13_);
#line 216 "../filechooser-module/FileChooserDialog.vala"
				if (_tmp14_ == NULL) {
#line 217 "../filechooser-module/FileChooserDialog.vala"
					gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data3_->w0, gtk_container_get_type ()) ? ((GtkContainer*) _data3_->w0) : NULL, _data4_->w1);
#line 1520 "FileChooserDialog.c"
				} else {
					GList* _tmp15_;
					GList* _tmp16_;
#line 219 "../filechooser-module/FileChooserDialog.vala"
					_tmp15_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data4_->w1, gtk_container_get_type ()) ? ((GtkContainer*) _data4_->w1) : NULL);
#line 219 "../filechooser-module/FileChooserDialog.vala"
					_tmp16_ = _tmp15_;
#line 219 "../filechooser-module/FileChooserDialog.vala"
					g_list_foreach (_tmp16_, _______lambda20__gfunc, _data4_);
#line 219 "../filechooser-module/FileChooserDialog.vala"
					(_tmp16_ == NULL) ? NULL : (_tmp16_ = (g_list_free (_tmp16_), NULL));
#line 1532 "FileChooserDialog.c"
				}
			}
		}
	}
#line 193 "../filechooser-module/FileChooserDialog.vala"
	block4_data_unref (_data4_);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_data4_ = NULL;
#line 1541 "FileChooserDialog.c"
}


static void
___lambda7__gfunc (gconstpointer data,
                   gpointer self)
{
#line 193 "../filechooser-module/FileChooserDialog.vala"
	__lambda7_ (self, (GtkWidget*) data);
#line 1551 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_transform_rootwidget_container (CustomFileChooserDialog* self,
                                                           GtkWidget* rootwidget,
                                                           GtkWidget* w0)
{
	Block3Data* _data3_;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 192 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (self != NULL);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (rootwidget != NULL);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w0 != NULL);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_data3_->_ref_count_ = 1;
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_data3_->self = g_object_ref (self);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = _g_object_ref0 (rootwidget);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (_data3_->rootwidget);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_data3_->rootwidget = _tmp0_;
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _g_object_ref0 (w0);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (_data3_->w0);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_data3_->w0 = _tmp1_;
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data3_->rootwidget, gtk_container_get_type ()) ? ((GtkContainer*) _data3_->rootwidget) : NULL);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = _tmp2_;
#line 193 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp3_, ___lambda7__gfunc, _data3_);
#line 193 "../filechooser-module/FileChooserDialog.vala"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 192 "../filechooser-module/FileChooserDialog.vala"
	block3_data_unref (_data3_);
#line 192 "../filechooser-module/FileChooserDialog.vala"
	_data3_ = NULL;
#line 1601 "FileChooserDialog.c"
}


static void
__lambda10_ (CustomFileChooserDialog* self,
             GtkWidget* w2)
{
#line 232 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w2 != NULL);
#line 233 "../filechooser-module/FileChooserDialog.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (w2, gtk_places_sidebar_get_type ())) {
#line 1613 "FileChooserDialog.c"
		GtkPlacesSidebar* sidebar = NULL;
		GtkPlacesSidebar* _tmp0_;
		GtkPlacesSidebar* _tmp1_;
		GtkPlacesSidebar* _tmp2_;
		GtkPlacesSidebar* _tmp3_;
#line 234 "../filechooser-module/FileChooserDialog.vala"
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w2, gtk_places_sidebar_get_type (), GtkPlacesSidebar));
#line 234 "../filechooser-module/FileChooserDialog.vala"
		sidebar = _tmp0_;
#line 235 "../filechooser-module/FileChooserDialog.vala"
		_tmp1_ = sidebar;
#line 235 "../filechooser-module/FileChooserDialog.vala"
		gtk_places_sidebar_set_show_desktop (_tmp1_, FALSE);
#line 236 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = sidebar;
#line 236 "../filechooser-module/FileChooserDialog.vala"
		gtk_places_sidebar_set_show_enter_location (_tmp2_, FALSE);
#line 237 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = sidebar;
#line 237 "../filechooser-module/FileChooserDialog.vala"
		gtk_places_sidebar_set_show_recent (_tmp3_, TRUE);
#line 233 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (sidebar);
#line 1637 "FileChooserDialog.c"
	} else {
#line 239 "../filechooser-module/FileChooserDialog.vala"
		custom_file_chooser_dialog_transform_w2_container (self, w2);
#line 1641 "FileChooserDialog.c"
	}
}


static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
#line 232 "../filechooser-module/FileChooserDialog.vala"
	__lambda10_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1652 "FileChooserDialog.c"
}


static void
__lambda9_ (CustomFileChooserDialog* self,
            GtkWidget* paned)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 231 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (paned != NULL);
#line 232 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (paned, gtk_container_get_type ()) ? ((GtkContainer*) paned) : NULL);
#line 232 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _tmp0_;
#line 232 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp1_, ___lambda10__gfunc, self);
#line 232 "../filechooser-module/FileChooserDialog.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1672 "FileChooserDialog.c"
}


static void
___lambda9__gfunc (gconstpointer data,
                   gpointer self)
{
#line 231 "../filechooser-module/FileChooserDialog.vala"
	__lambda9_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1682 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_transform_w1_container (CustomFileChooserDialog* self,
                                                   GtkWidget* w1)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 230 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (self != NULL);
#line 230 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w1 != NULL);
#line 231 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w1, gtk_container_get_type ()) ? ((GtkContainer*) w1) : NULL);
#line 231 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _tmp0_;
#line 231 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp1_, ___lambda9__gfunc, self);
#line 231 "../filechooser-module/FileChooserDialog.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1704 "FileChooserDialog.c"
}


static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 245 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	return _data5_;
#line 1715 "FileChooserDialog.c"
}


static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 245 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1726 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 245 "../filechooser-module/FileChooserDialog.vala"
		self = _data5_->self;
#line 245 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data5_->w2);
#line 245 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (self);
#line 245 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block5Data, _data5_);
#line 1736 "FileChooserDialog.c"
	}
}


static void
___lambda15_ (CustomFileChooserDialog* self,
              GtkWidget* w7)
{
#line 252 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w7 != NULL);
#line 253 "../filechooser-module/FileChooserDialog.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (w7, gtk_button_get_type ())) {
#line 255 "../filechooser-module/FileChooserDialog.vala"
		self->priv->gtk_folder_button = G_TYPE_CHECK_INSTANCE_TYPE (w7, gtk_button_get_type ()) ? ((GtkButton*) w7) : NULL;
#line 1751 "FileChooserDialog.c"
	}
}


static void
____lambda15__gfunc (gconstpointer data,
                     gpointer self)
{
#line 252 "../filechooser-module/FileChooserDialog.vala"
	___lambda15_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1762 "FileChooserDialog.c"
}


static void
__lambda14_ (CustomFileChooserDialog* self,
             GtkWidget* w6)
{
#line 250 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w6 != NULL);
#line 251 "../filechooser-module/FileChooserDialog.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (w6, gtk_box_get_type ())) {
#line 1774 "FileChooserDialog.c"
		GList* _tmp0_;
		GList* _tmp1_;
#line 252 "../filechooser-module/FileChooserDialog.vala"
		_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w6, gtk_container_get_type ()) ? ((GtkContainer*) w6) : NULL);
#line 252 "../filechooser-module/FileChooserDialog.vala"
		_tmp1_ = _tmp0_;
#line 252 "../filechooser-module/FileChooserDialog.vala"
		g_list_foreach (_tmp1_, ____lambda15__gfunc, self);
#line 252 "../filechooser-module/FileChooserDialog.vala"
		(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1785 "FileChooserDialog.c"
	}
}


static void
___lambda14__gfunc (gconstpointer data,
                    gpointer self)
{
#line 250 "../filechooser-module/FileChooserDialog.vala"
	__lambda14_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1796 "FileChooserDialog.c"
}


static void
__lambda13_ (CustomFileChooserDialog* self,
             GtkWidget* w5)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 249 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w5 != NULL);
#line 250 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w5, gtk_container_get_type ()) ? ((GtkContainer*) w5) : NULL);
#line 250 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _tmp0_;
#line 250 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp1_, ___lambda14__gfunc, self);
#line 250 "../filechooser-module/FileChooserDialog.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1816 "FileChooserDialog.c"
}


static void
___lambda13__gfunc (gconstpointer data,
                    gpointer self)
{
#line 249 "../filechooser-module/FileChooserDialog.vala"
	__lambda13_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1826 "FileChooserDialog.c"
}


static void
___lambda12_ (CustomFileChooserDialog* self,
              GtkWidget* w4)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 248 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w4 != NULL);
#line 249 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w4, gtk_container_get_type ()) ? ((GtkContainer*) w4) : NULL);
#line 249 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _tmp0_;
#line 249 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp1_, ___lambda13__gfunc, self);
#line 249 "../filechooser-module/FileChooserDialog.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 1846 "FileChooserDialog.c"
}


static void
____lambda12__gfunc (gconstpointer data,
                     gpointer self)
{
#line 248 "../filechooser-module/FileChooserDialog.vala"
	___lambda12_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 1856 "FileChooserDialog.c"
}


static gboolean
_custom_file_chooser_dialog_on_tv_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                    GdkEventButton* event,
                                                                                    gpointer self)
{
	gboolean result;
	result = custom_file_chooser_dialog_on_tv_button_press_event ((CustomFileChooserDialog*) self, _sender, event);
#line 272 "../filechooser-module/FileChooserDialog.vala"
	return result;
#line 1869 "FileChooserDialog.c"
}


static gboolean
_custom_file_chooser_dialog_on_tv_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                        GdkEventButton* event,
                                                                                        gpointer self)
{
	gboolean result;
	result = custom_file_chooser_dialog_on_tv_button_release_event ((CustomFileChooserDialog*) self, event);
#line 273 "../filechooser-module/FileChooserDialog.vala"
	return result;
#line 1882 "FileChooserDialog.c"
}


static void
__lambda11_ (Block5Data* _data5_,
             GtkWidget* w3)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 246 "../filechooser-module/FileChooserDialog.vala"
	self = _data5_->self;
#line 246 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w3 != NULL);
#line 247 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w3);
#line 247 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_PATHBAR_PATH[3];
#line 247 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 1903 "FileChooserDialog.c"
		GList* _tmp2_;
		GList* _tmp3_;
#line 248 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (w3, gtk_container_get_type ()) ? ((GtkContainer*) w3) : NULL);
#line 248 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = _tmp2_;
#line 248 "../filechooser-module/FileChooserDialog.vala"
		g_list_foreach (_tmp3_, ____lambda12__gfunc, self);
#line 248 "../filechooser-module/FileChooserDialog.vala"
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 263 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_TYPE (_data5_->w2, gtk_container_get_type ()) ? ((GtkContainer*) _data5_->w2) : NULL, w3);
#line 1916 "FileChooserDialog.c"
	} else {
		const gchar* _tmp4_;
#line 264 "../filechooser-module/FileChooserDialog.vala"
		_tmp4_ = gtk_buildable_get_name ((GtkBuildable*) w3);
#line 264 "../filechooser-module/FileChooserDialog.vala"
		if (g_strcmp0 (_tmp4_, "list_and_preview_box") == 0) {
#line 1923 "FileChooserDialog.c"
			GtkTreeView* tv = NULL;
			GtkTreeView* _tmp5_;
			GtkTreeView* _tmp6_;
#line 265 "../filechooser-module/FileChooserDialog.vala"
			_tmp5_ = custom_file_chooser_dialog_find_tree_view (self, w3);
#line 265 "../filechooser-module/FileChooserDialog.vala"
			tv = _tmp5_;
#line 266 "../filechooser-module/FileChooserDialog.vala"
			_tmp6_ = tv;
#line 266 "../filechooser-module/FileChooserDialog.vala"
			if (_tmp6_ != NULL) {
#line 1935 "FileChooserDialog.c"
				GtkTreeView* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
#line 268 "../filechooser-module/FileChooserDialog.vala"
				_tmp7_ = tv;
#line 268 "../filechooser-module/FileChooserDialog.vala"
				_tmp8_ = self->priv->is_single_click;
#line 268 "../filechooser-module/FileChooserDialog.vala"
				gtk_tree_view_set_activate_on_single_click (_tmp7_, _tmp8_);
#line 269 "../filechooser-module/FileChooserDialog.vala"
				_tmp9_ = self->priv->is_single_click;
#line 269 "../filechooser-module/FileChooserDialog.vala"
				if (_tmp9_) {
#line 1949 "FileChooserDialog.c"
					GtkTreeView* _tmp10_;
					GtkTreeView* _tmp11_;
					GtkTreeView* _tmp12_;
#line 271 "../filechooser-module/FileChooserDialog.vala"
					_tmp10_ = tv;
#line 271 "../filechooser-module/FileChooserDialog.vala"
					gtk_widget_add_events ((GtkWidget*) _tmp10_, (gint) (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK));
#line 272 "../filechooser-module/FileChooserDialog.vala"
					_tmp11_ = tv;
#line 272 "../filechooser-module/FileChooserDialog.vala"
					g_signal_connect_object ((GtkWidget*) _tmp11_, "button-press-event", (GCallback) _custom_file_chooser_dialog_on_tv_button_press_event_gtk_widget_button_press_event, self, 0);
#line 273 "../filechooser-module/FileChooserDialog.vala"
					_tmp12_ = tv;
#line 273 "../filechooser-module/FileChooserDialog.vala"
					g_signal_connect_object ((GtkWidget*) _tmp12_, "button-release-event", (GCallback) _custom_file_chooser_dialog_on_tv_button_release_event_gtk_widget_button_release_event, self, 0);
#line 1965 "FileChooserDialog.c"
				}
			}
#line 264 "../filechooser-module/FileChooserDialog.vala"
			_g_object_unref0 (tv);
#line 1970 "FileChooserDialog.c"
		}
	}
}


static void
___lambda11__gfunc (gconstpointer data,
                    gpointer self)
{
#line 246 "../filechooser-module/FileChooserDialog.vala"
	__lambda11_ (self, (GtkWidget*) data);
#line 1982 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_transform_w2_container (CustomFileChooserDialog* self,
                                                   GtkWidget* w2)
{
	Block5Data* _data5_;
	GtkWidget* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 245 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (self != NULL);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w2 != NULL);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_data5_->_ref_count_ = 1;
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_data5_->self = g_object_ref (self);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = _g_object_ref0 (w2);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (_data5_->w2);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_data5_->w2 = _tmp0_;
#line 246 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_TYPE (_data5_->w2, gtk_container_get_type ()) ? ((GtkContainer*) _data5_->w2) : NULL);
#line 246 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = _tmp1_;
#line 246 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp2_, ___lambda11__gfunc, _data5_);
#line 246 "../filechooser-module/FileChooserDialog.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 245 "../filechooser-module/FileChooserDialog.vala"
	block5_data_unref (_data5_);
#line 245 "../filechooser-module/FileChooserDialog.vala"
	_data5_ = NULL;
#line 2022 "FileChooserDialog.c"
}


static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 280 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 280 "../filechooser-module/FileChooserDialog.vala"
	return _data6_;
#line 2033 "FileChooserDialog.c"
}


static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 280 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2044 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 280 "../filechooser-module/FileChooserDialog.vala"
		self = _data6_->self;
#line 280 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data6_->tv);
#line 280 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (self);
#line 280 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block6Data, _data6_);
#line 2054 "FileChooserDialog.c"
	}
}


static void
___lambda19_ (Block6Data* _data6_,
              GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 289 "../filechooser-module/FileChooserDialog.vala"
	self = _data6_->self;
#line 289 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w != NULL);
#line 290 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w);
#line 290 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[2];
#line 290 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 2076 "FileChooserDialog.c"
		GtkTreeView* _tmp2_;
#line 291 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_tree_view_get_type (), GtkTreeView));
#line 291 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data6_->tv);
#line 291 "../filechooser-module/FileChooserDialog.vala"
		_data6_->tv = _tmp2_;
#line 2084 "FileChooserDialog.c"
	}
}


static void
____lambda19__gfunc (gconstpointer data,
                     gpointer self)
{
#line 289 "../filechooser-module/FileChooserDialog.vala"
	___lambda19_ (self, (GtkWidget*) data);
#line 2095 "FileChooserDialog.c"
}


static void
___lambda18_ (Block6Data* _data6_,
              GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 287 "../filechooser-module/FileChooserDialog.vala"
	self = _data6_->self;
#line 287 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w != NULL);
#line 288 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w);
#line 288 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[1];
#line 288 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 2116 "FileChooserDialog.c"
		GList* _tmp2_;
		GList* _tmp3_;
#line 289 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_container_get_type (), GtkContainer));
#line 289 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = _tmp2_;
#line 289 "../filechooser-module/FileChooserDialog.vala"
		g_list_foreach (_tmp3_, ____lambda19__gfunc, _data6_);
#line 289 "../filechooser-module/FileChooserDialog.vala"
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 2127 "FileChooserDialog.c"
	}
}


static void
____lambda18__gfunc (gconstpointer data,
                     gpointer self)
{
#line 287 "../filechooser-module/FileChooserDialog.vala"
	___lambda18_ (self, (GtkWidget*) data);
#line 2138 "FileChooserDialog.c"
}


static void
___lambda17_ (Block6Data* _data6_,
              GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 285 "../filechooser-module/FileChooserDialog.vala"
	self = _data6_->self;
#line 285 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w != NULL);
#line 286 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_widget_get_name (w);
#line 286 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _tmp0_;
#line 286 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp1_, "GtkBox") == 0) {
#line 2159 "FileChooserDialog.c"
		GList* _tmp2_;
		GList* _tmp3_;
#line 287 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_container_get_type (), GtkContainer));
#line 287 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = _tmp2_;
#line 287 "../filechooser-module/FileChooserDialog.vala"
		g_list_foreach (_tmp3_, ____lambda18__gfunc, _data6_);
#line 287 "../filechooser-module/FileChooserDialog.vala"
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 2170 "FileChooserDialog.c"
	}
}


static void
____lambda17__gfunc (gconstpointer data,
                     gpointer self)
{
#line 285 "../filechooser-module/FileChooserDialog.vala"
	___lambda17_ (self, (GtkWidget*) data);
#line 2181 "FileChooserDialog.c"
}


static void
__lambda16_ (Block6Data* _data6_,
             GtkWidget* w)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 283 "../filechooser-module/FileChooserDialog.vala"
	self = _data6_->self;
#line 283 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (w != NULL);
#line 284 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_buildable_get_name ((GtkBuildable*) w);
#line 284 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = CUSTOM_FILE_CHOOSER_DIALOG_GTK_TREEVIEW_PATH[0];
#line 284 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 2202 "FileChooserDialog.c"
		GList* _tmp2_;
		GList* _tmp3_;
#line 285 "../filechooser-module/FileChooserDialog.vala"
		_tmp2_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_container_get_type (), GtkContainer));
#line 285 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = _tmp2_;
#line 285 "../filechooser-module/FileChooserDialog.vala"
		g_list_foreach (_tmp3_, ____lambda17__gfunc, _data6_);
#line 285 "../filechooser-module/FileChooserDialog.vala"
		(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_list_free (_tmp3_), NULL));
#line 2213 "FileChooserDialog.c"
	}
}


static void
___lambda16__gfunc (gconstpointer data,
                    gpointer self)
{
#line 283 "../filechooser-module/FileChooserDialog.vala"
	__lambda16_ (self, (GtkWidget*) data);
#line 2224 "FileChooserDialog.c"
}


static GtkTreeView*
custom_file_chooser_dialog_find_tree_view (CustomFileChooserDialog* self,
                                           GtkWidget* browser_box)
{
	GtkTreeView* result = NULL;
	Block6Data* _data6_;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkTreeView* _tmp2_;
#line 280 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 280 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (browser_box != NULL, NULL);
#line 280 "../filechooser-module/FileChooserDialog.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 280 "../filechooser-module/FileChooserDialog.vala"
	_data6_->_ref_count_ = 1;
#line 280 "../filechooser-module/FileChooserDialog.vala"
	_data6_->self = g_object_ref (self);
#line 282 "../filechooser-module/FileChooserDialog.vala"
	_data6_->tv = NULL;
#line 283 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_container_get_children (G_TYPE_CHECK_INSTANCE_CAST (browser_box, gtk_container_get_type (), GtkContainer));
#line 283 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _tmp0_;
#line 283 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp1_, ___lambda16__gfunc, _data6_);
#line 283 "../filechooser-module/FileChooserDialog.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_list_free (_tmp1_), NULL));
#line 301 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = _g_object_ref0 (_data6_->tv);
#line 301 "../filechooser-module/FileChooserDialog.vala"
	result = _tmp2_;
#line 301 "../filechooser-module/FileChooserDialog.vala"
	block6_data_unref (_data6_);
#line 301 "../filechooser-module/FileChooserDialog.vala"
	_data6_ = NULL;
#line 301 "../filechooser-module/FileChooserDialog.vala"
	return result;
#line 2267 "FileChooserDialog.c"
}


static void
__lambda4_ (CustomFileChooserDialog* self,
            GtkWidget* child)
{
#line 307 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (child != NULL);
#line 308 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_valign (child, GTK_ALIGN_CENTER);
#line 2279 "FileChooserDialog.c"
}


static void
___lambda4__gfunc (gconstpointer data,
                   gpointer self)
{
#line 307 "../filechooser-module/FileChooserDialog.vala"
	__lambda4_ ((CustomFileChooserDialog*) self, (GtkWidget*) data);
#line 2289 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_assign_container_box (CustomFileChooserDialog* self)
{
	GtkFileChooserDialog* _tmp0_;
	GtkWidget* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
#line 304 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (self != NULL);
#line 305 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->chooser_dialog;
#line 305 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = gtk_dialog_get_action_area ((GtkDialog*) _tmp0_);
#line 305 "../filechooser-module/FileChooserDialog.vala"
	self->priv->container_box = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_box_get_type ()) ? ((GtkBox*) _tmp1_) : NULL;
#line 306 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = self->priv->container_box;
#line 306 "../filechooser-module/FileChooserDialog.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
#line 307 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = self->priv->container_box;
#line 307 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = gtk_container_get_children ((GtkContainer*) _tmp3_);
#line 307 "../filechooser-module/FileChooserDialog.vala"
	_tmp5_ = _tmp4_;
#line 307 "../filechooser-module/FileChooserDialog.vala"
	g_list_foreach (_tmp5_, ___lambda4__gfunc, self);
#line 307 "../filechooser-module/FileChooserDialog.vala"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_list_free (_tmp5_), NULL));
#line 2324 "FileChooserDialog.c"
}


static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 315 "../filechooser-module/FileChooserDialog.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 315 "../filechooser-module/FileChooserDialog.vala"
	return _data7_;
#line 2335 "FileChooserDialog.c"
}


static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 315 "../filechooser-module/FileChooserDialog.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2346 "FileChooserDialog.c"
		CustomFileChooserDialog* self;
#line 315 "../filechooser-module/FileChooserDialog.vala"
		self = _data7_->self;
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (_data7_->combo_box);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (_data7_->current_filter_name);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (self);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		g_slice_free (Block7Data, _data7_);
#line 2358 "FileChooserDialog.c"
	}
}


static void
__lambda22_ (Block7Data* _data7_,
             GtkFileFilter* filter)
{
	CustomFileChooserDialog* self;
	const gchar* _tmp0_;
	GtkComboBoxText* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 325 "../filechooser-module/FileChooserDialog.vala"
	self = _data7_->self;
#line 325 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (filter != NULL);
#line 326 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_file_filter_get_name (filter);
#line 326 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _data7_->combo_box;
#line 326 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = gtk_combo_box_text_get_active_text (_tmp1_);
#line 326 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = _tmp2_;
#line 326 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = g_strcmp0 (_tmp0_, _tmp3_) == 0;
#line 326 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (_tmp3_);
#line 326 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp4_) {
#line 2391 "FileChooserDialog.c"
		GtkFileChooserDialog* _tmp5_;
#line 327 "../filechooser-module/FileChooserDialog.vala"
		_tmp5_ = self->priv->chooser_dialog;
#line 327 "../filechooser-module/FileChooserDialog.vala"
		gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp5_, filter);
#line 2397 "FileChooserDialog.c"
	}
}


static void
___lambda22__gfunc (gconstpointer data,
                    gpointer self)
{
#line 325 "../filechooser-module/FileChooserDialog.vala"
	__lambda22_ (self, (GtkFileFilter*) data);
#line 2408 "FileChooserDialog.c"
}


static void
___lambda21_ (Block7Data* _data7_)
{
	CustomFileChooserDialog* self;
	GtkFileChooserDialog* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
#line 324 "../filechooser-module/FileChooserDialog.vala"
	self = _data7_->self;
#line 325 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->chooser_dialog;
#line 325 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = gtk_file_chooser_list_filters ((GtkFileChooser*) _tmp0_);
#line 325 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = _tmp1_;
#line 325 "../filechooser-module/FileChooserDialog.vala"
	g_slist_foreach (_tmp2_, ___lambda22__gfunc, _data7_);
#line 325 "../filechooser-module/FileChooserDialog.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_slist_free (_tmp2_), NULL));
#line 2431 "FileChooserDialog.c"
}


static void
____lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                     gpointer self)
{
#line 324 "../filechooser-module/FileChooserDialog.vala"
	___lambda21_ (self);
#line 2441 "FileChooserDialog.c"
}


static void
___lambda23_ (Block7Data* _data7_,
              GtkFileFilter* filter)
{
	CustomFileChooserDialog* self;
	gchar* name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GtkComboBoxText* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gint _tmp8_;
#line 333 "../filechooser-module/FileChooserDialog.vala"
	self = _data7_->self;
#line 333 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (filter != NULL);
#line 334 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = gtk_file_filter_get_name (filter);
#line 334 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 334 "../filechooser-module/FileChooserDialog.vala"
	name = _tmp1_;
#line 335 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = _data7_->combo_box;
#line 335 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = name;
#line 335 "../filechooser-module/FileChooserDialog.vala"
	gtk_combo_box_text_append_text (_tmp2_, _tmp3_);
#line 336 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = name;
#line 336 "../filechooser-module/FileChooserDialog.vala"
	_tmp5_ = _data7_->current_filter_name;
#line 336 "../filechooser-module/FileChooserDialog.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
#line 2480 "FileChooserDialog.c"
		GtkComboBoxText* _tmp6_;
		gint _tmp7_;
#line 337 "../filechooser-module/FileChooserDialog.vala"
		_tmp6_ = _data7_->combo_box;
#line 337 "../filechooser-module/FileChooserDialog.vala"
		_tmp7_ = _data7_->index;
#line 337 "../filechooser-module/FileChooserDialog.vala"
		gtk_combo_box_set_active ((GtkComboBox*) _tmp6_, _tmp7_);
#line 2489 "FileChooserDialog.c"
	}
#line 340 "../filechooser-module/FileChooserDialog.vala"
	_tmp8_ = _data7_->index;
#line 340 "../filechooser-module/FileChooserDialog.vala"
	_data7_->index = _tmp8_ + 1;
#line 333 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (name);
#line 2497 "FileChooserDialog.c"
}


static void
____lambda23__gfunc (gconstpointer data,
                     gpointer self)
{
#line 333 "../filechooser-module/FileChooserDialog.vala"
	___lambda23_ (self, (GtkFileFilter*) data);
#line 2507 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_setup_filter_box (CustomFileChooserDialog* self)
{
	GSList* filters = NULL;
	GtkFileChooserDialog* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
#line 312 "../filechooser-module/FileChooserDialog.vala"
	g_return_if_fail (self != NULL);
#line 313 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->chooser_dialog;
#line 313 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = gtk_file_chooser_list_filters ((GtkFileChooser*) _tmp0_);
#line 313 "../filechooser-module/FileChooserDialog.vala"
	filters = _tmp1_;
#line 315 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = filters;
#line 315 "../filechooser-module/FileChooserDialog.vala"
	if (g_slist_length (_tmp2_) > ((guint) 0)) {
#line 2530 "FileChooserDialog.c"
		Block7Data* _data7_;
		GtkFileFilter* current_filter = NULL;
		GtkFileChooserDialog* _tmp3_;
		GtkFileFilter* _tmp4_;
		GtkFileFilter* _tmp5_;
		GtkFileFilter* _tmp6_;
		GtkComboBoxText* _tmp10_;
		GtkComboBoxText* _tmp11_;
		GSList* _tmp12_;
		GtkGrid* grid = NULL;
		GtkGrid* _tmp13_;
		GtkGrid* _tmp14_;
		GtkGrid* _tmp15_;
		GtkComboBoxText* _tmp16_;
		GtkBox* _tmp17_;
		GtkGrid* _tmp18_;
		GtkBox* _tmp19_;
		GtkGrid* _tmp20_;
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_data7_ = g_slice_new0 (Block7Data);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_data7_->_ref_count_ = 1;
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_data7_->self = g_object_ref (self);
#line 316 "../filechooser-module/FileChooserDialog.vala"
		_data7_->current_filter_name = NULL;
#line 317 "../filechooser-module/FileChooserDialog.vala"
		_tmp3_ = self->priv->chooser_dialog;
#line 317 "../filechooser-module/FileChooserDialog.vala"
		_tmp4_ = gtk_file_chooser_get_filter ((GtkFileChooser*) _tmp3_);
#line 317 "../filechooser-module/FileChooserDialog.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 317 "../filechooser-module/FileChooserDialog.vala"
		current_filter = _tmp5_;
#line 318 "../filechooser-module/FileChooserDialog.vala"
		_tmp6_ = current_filter;
#line 318 "../filechooser-module/FileChooserDialog.vala"
		if (_tmp6_ != NULL) {
#line 2569 "FileChooserDialog.c"
			GtkFileFilter* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
#line 319 "../filechooser-module/FileChooserDialog.vala"
			_tmp7_ = current_filter;
#line 319 "../filechooser-module/FileChooserDialog.vala"
			_tmp8_ = gtk_file_filter_get_name (_tmp7_);
#line 319 "../filechooser-module/FileChooserDialog.vala"
			_tmp9_ = g_strdup (_tmp8_);
#line 319 "../filechooser-module/FileChooserDialog.vala"
			_g_free0 (_data7_->current_filter_name);
#line 319 "../filechooser-module/FileChooserDialog.vala"
			_data7_->current_filter_name = _tmp9_;
#line 2583 "FileChooserDialog.c"
		}
#line 322 "../filechooser-module/FileChooserDialog.vala"
		self->priv->filters_available = TRUE;
#line 323 "../filechooser-module/FileChooserDialog.vala"
		_tmp10_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 323 "../filechooser-module/FileChooserDialog.vala"
		g_object_ref_sink (_tmp10_);
#line 323 "../filechooser-module/FileChooserDialog.vala"
		_data7_->combo_box = _tmp10_;
#line 324 "../filechooser-module/FileChooserDialog.vala"
		_tmp11_ = _data7_->combo_box;
#line 324 "../filechooser-module/FileChooserDialog.vala"
		g_signal_connect_data ((GtkComboBox*) _tmp11_, "changed", (GCallback) ____lambda21__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 332 "../filechooser-module/FileChooserDialog.vala"
		_data7_->index = 0;
#line 333 "../filechooser-module/FileChooserDialog.vala"
		_tmp12_ = filters;
#line 333 "../filechooser-module/FileChooserDialog.vala"
		g_slist_foreach (_tmp12_, ____lambda23__gfunc, _data7_);
#line 343 "../filechooser-module/FileChooserDialog.vala"
		_tmp13_ = (GtkGrid*) gtk_grid_new ();
#line 343 "../filechooser-module/FileChooserDialog.vala"
		g_object_ref_sink (_tmp13_);
#line 343 "../filechooser-module/FileChooserDialog.vala"
		grid = _tmp13_;
#line 344 "../filechooser-module/FileChooserDialog.vala"
		_tmp14_ = grid;
#line 344 "../filechooser-module/FileChooserDialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
#line 345 "../filechooser-module/FileChooserDialog.vala"
		_tmp15_ = grid;
#line 345 "../filechooser-module/FileChooserDialog.vala"
		_tmp16_ = _data7_->combo_box;
#line 345 "../filechooser-module/FileChooserDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 346 "../filechooser-module/FileChooserDialog.vala"
		_tmp17_ = self->priv->container_box;
#line 346 "../filechooser-module/FileChooserDialog.vala"
		_tmp18_ = grid;
#line 346 "../filechooser-module/FileChooserDialog.vala"
		gtk_box_pack_end (_tmp17_, (GtkWidget*) _tmp18_, TRUE, TRUE, (guint) 0);
#line 347 "../filechooser-module/FileChooserDialog.vala"
		_tmp19_ = self->priv->container_box;
#line 347 "../filechooser-module/FileChooserDialog.vala"
		_tmp20_ = grid;
#line 347 "../filechooser-module/FileChooserDialog.vala"
		gtk_button_box_set_child_secondary (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_button_box_get_type (), GtkButtonBox), (GtkWidget*) _tmp20_, TRUE);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (grid);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (current_filter);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		block7_data_unref (_data7_);
#line 315 "../filechooser-module/FileChooserDialog.vala"
		_data7_ = NULL;
#line 2639 "FileChooserDialog.c"
	}
#line 312 "../filechooser-module/FileChooserDialog.vala"
	(filters == NULL) ? NULL : (filters = (g_slist_free (filters), NULL));
#line 2643 "FileChooserDialog.c"
}


static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 366 "../filechooser-module/FileChooserDialog.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2652 "FileChooserDialog.c"
}


static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
#line 371 "../filechooser-module/FileChooserDialog.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 371 "../filechooser-module/FileChooserDialog.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 371 "../filechooser-module/FileChooserDialog.vala"
	return dup;
#line 2666 "FileChooserDialog.c"
}


static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
#line 371 "../filechooser-module/FileChooserDialog.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 2675 "FileChooserDialog.c"
}


static gboolean
custom_file_chooser_dialog_on_tv_button_press_event (CustomFileChooserDialog* self,
                                                     GtkWidget* w,
                                                     GdkEventButton* event)
{
	gboolean result = FALSE;
	GdkEventType _tmp0_;
	GtkTreeView* tv = NULL;
	GtkTreeView* _tmp1_;
	GtkTreePath* path = NULL;
	gint cell_x = 0;
	gint cell_y = 0;
	GtkTreeView* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	GtkTreePath* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	GtkTreePath* _tmp8_;
#line 351 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 351 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (w != NULL, FALSE);
#line 351 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 352 "../filechooser-module/FileChooserDialog.vala"
	self->priv->can_activate = FALSE;
#line 353 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = event->type;
#line 353 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp0_ == GDK_2BUTTON_PRESS) {
#line 354 "../filechooser-module/FileChooserDialog.vala"
		self->priv->can_activate = TRUE;
#line 355 "../filechooser-module/FileChooserDialog.vala"
		result = FALSE;
#line 355 "../filechooser-module/FileChooserDialog.vala"
		return result;
#line 2716 "FileChooserDialog.c"
	}
#line 358 "../filechooser-module/FileChooserDialog.vala"
	if (w == NULL) {
#line 359 "../filechooser-module/FileChooserDialog.vala"
		result = FALSE;
#line 359 "../filechooser-module/FileChooserDialog.vala"
		return result;
#line 2724 "FileChooserDialog.c"
	}
#line 362 "../filechooser-module/FileChooserDialog.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w, gtk_tree_view_get_type (), GtkTreeView));
#line 362 "../filechooser-module/FileChooserDialog.vala"
	tv = _tmp1_;
#line 363 "../filechooser-module/FileChooserDialog.vala"
	path = NULL;
#line 366 "../filechooser-module/FileChooserDialog.vala"
	_tmp2_ = tv;
#line 366 "../filechooser-module/FileChooserDialog.vala"
	_tmp3_ = event->x;
#line 366 "../filechooser-module/FileChooserDialog.vala"
	_tmp4_ = event->y;
#line 366 "../filechooser-module/FileChooserDialog.vala"
	gtk_tree_view_get_path_at_pos (_tmp2_, (gint) _tmp3_, (gint) _tmp4_, &_tmp5_, NULL, &_tmp6_, &_tmp7_);
#line 366 "../filechooser-module/FileChooserDialog.vala"
	__vala_GtkTreePath_free0 (path);
#line 366 "../filechooser-module/FileChooserDialog.vala"
	path = _tmp5_;
#line 366 "../filechooser-module/FileChooserDialog.vala"
	cell_x = _tmp6_;
#line 366 "../filechooser-module/FileChooserDialog.vala"
	cell_y = _tmp7_;
#line 368 "../filechooser-module/FileChooserDialog.vala"
	_tmp8_ = path;
#line 368 "../filechooser-module/FileChooserDialog.vala"
	if (_tmp8_ != NULL) {
#line 2752 "FileChooserDialog.c"
		GtkTreeModel* model = NULL;
		GtkTreeView* _tmp9_;
		GtkTreeModel* _tmp10_;
		GtkTreeModel* _tmp11_;
		GtkTreeIter* iter = NULL;
		GtkTreeModel* _tmp12_;
		GtkTreePath* _tmp13_;
		GtkTreeIter _tmp14_ = {0};
		gboolean _tmp15_;
		GtkTreeIter _tmp16_;
		GtkTreeIter* _tmp17_;
#line 369 "../filechooser-module/FileChooserDialog.vala"
		_tmp9_ = tv;
#line 369 "../filechooser-module/FileChooserDialog.vala"
		_tmp10_ = gtk_tree_view_get_model (_tmp9_);
#line 369 "../filechooser-module/FileChooserDialog.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 369 "../filechooser-module/FileChooserDialog.vala"
		model = _tmp11_;
#line 370 "../filechooser-module/FileChooserDialog.vala"
		iter = NULL;
#line 371 "../filechooser-module/FileChooserDialog.vala"
		_tmp12_ = model;
#line 371 "../filechooser-module/FileChooserDialog.vala"
		_tmp13_ = path;
#line 371 "../filechooser-module/FileChooserDialog.vala"
		_tmp15_ = gtk_tree_model_get_iter (_tmp12_, &_tmp14_, _tmp13_);
#line 371 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (iter);
#line 371 "../filechooser-module/FileChooserDialog.vala"
		_tmp16_ = _tmp14_;
#line 371 "../filechooser-module/FileChooserDialog.vala"
		_tmp17_ = __gtk_tree_iter_dup0 (&_tmp16_);
#line 371 "../filechooser-module/FileChooserDialog.vala"
		iter = _tmp17_;
#line 371 "../filechooser-module/FileChooserDialog.vala"
		if (_tmp15_) {
#line 2790 "FileChooserDialog.c"
			gboolean is_folder = FALSE;
			GtkTreeModel* _tmp18_;
			GtkTreeIter* _tmp19_;
			GtkTreeIter _tmp20_;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_;
#line 373 "../filechooser-module/FileChooserDialog.vala"
			_tmp18_ = model;
#line 373 "../filechooser-module/FileChooserDialog.vala"
			_tmp19_ = iter;
#line 373 "../filechooser-module/FileChooserDialog.vala"
			_tmp20_ = *_tmp19_;
#line 373 "../filechooser-module/FileChooserDialog.vala"
			gtk_tree_model_get (_tmp18_, &_tmp20_, 5, &_tmp21_, -1);
#line 373 "../filechooser-module/FileChooserDialog.vala"
			is_folder = _tmp21_;
#line 374 "../filechooser-module/FileChooserDialog.vala"
			_tmp22_ = is_folder;
#line 374 "../filechooser-module/FileChooserDialog.vala"
			if (_tmp22_) {
#line 375 "../filechooser-module/FileChooserDialog.vala"
				self->priv->can_activate = TRUE;
#line 2813 "FileChooserDialog.c"
			}
		}
#line 368 "../filechooser-module/FileChooserDialog.vala"
		_g_free0 (iter);
#line 368 "../filechooser-module/FileChooserDialog.vala"
		_g_object_unref0 (model);
#line 2820 "FileChooserDialog.c"
	}
#line 380 "../filechooser-module/FileChooserDialog.vala"
	result = FALSE;
#line 380 "../filechooser-module/FileChooserDialog.vala"
	__vala_GtkTreePath_free0 (path);
#line 380 "../filechooser-module/FileChooserDialog.vala"
	_g_object_unref0 (tv);
#line 380 "../filechooser-module/FileChooserDialog.vala"
	return result;
#line 2830 "FileChooserDialog.c"
}


static gboolean
custom_file_chooser_dialog_on_tv_button_release_event (CustomFileChooserDialog* self,
                                                       GdkEventButton* event)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 383 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 383 "../filechooser-module/FileChooserDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 384 "../filechooser-module/FileChooserDialog.vala"
	_tmp0_ = self->priv->can_activate;
#line 384 "../filechooser-module/FileChooserDialog.vala"
	result = !_tmp0_;
#line 384 "../filechooser-module/FileChooserDialog.vala"
	return result;
#line 2850 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_class_init (CustomFileChooserDialogClass * klass)
{
#line 25 "../filechooser-module/FileChooserDialog.vala"
	custom_file_chooser_dialog_parent_class = g_type_class_peek_parent (klass);
#line 25 "../filechooser-module/FileChooserDialog.vala"
	g_type_class_adjust_private_offset (klass, &CustomFileChooserDialog_private_offset);
#line 25 "../filechooser-module/FileChooserDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = custom_file_chooser_dialog_finalize;
#line 2863 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_instance_init (CustomFileChooserDialog * self)
{
#line 25 "../filechooser-module/FileChooserDialog.vala"
	self->priv = custom_file_chooser_dialog_get_instance_private (self);
#line 40 "../filechooser-module/FileChooserDialog.vala"
	self->priv->gtk_folder_button = NULL;
#line 45 "../filechooser-module/FileChooserDialog.vala"
	self->priv->filters_available = FALSE;
#line 47 "../filechooser-module/FileChooserDialog.vala"
	self->priv->current_path = NULL;
#line 48 "../filechooser-module/FileChooserDialog.vala"
	self->priv->is_previous = FALSE;
#line 49 "../filechooser-module/FileChooserDialog.vala"
	self->priv->is_button_next = FALSE;
#line 50 "../filechooser-module/FileChooserDialog.vala"
	self->priv->is_single_click = TRUE;
#line 51 "../filechooser-module/FileChooserDialog.vala"
	self->priv->can_activate = TRUE;
#line 2886 "FileChooserDialog.c"
}


static void
custom_file_chooser_dialog_finalize (GObject * obj)
{
	CustomFileChooserDialog * self;
#line 25 "../filechooser-module/FileChooserDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CUSTOM_FILE_CHOOSER_DIALOG, CustomFileChooserDialog);
#line 42 "../filechooser-module/FileChooserDialog.vala"
	(self->priv->previous_paths == NULL) ? NULL : (self->priv->previous_paths = (_g_queue_free__g_free0_ (self->priv->previous_paths), NULL));
#line 43 "../filechooser-module/FileChooserDialog.vala"
	(self->priv->next_paths == NULL) ? NULL : (self->priv->next_paths = (_g_queue_free__g_free0_ (self->priv->next_paths), NULL));
#line 47 "../filechooser-module/FileChooserDialog.vala"
	_g_free0 (self->priv->current_path);
#line 25 "../filechooser-module/FileChooserDialog.vala"
	G_OBJECT_CLASS (custom_file_chooser_dialog_parent_class)->finalize (obj);
#line 2904 "FileChooserDialog.c"
}


/*** The Gtk.FileChooserWidget widget names and paths can be found in "gtkfilechooserwidget.ui"
 *   in the Gtk+3 source code package.  Changes to that file could break this code.
***/
GType
custom_file_chooser_dialog_get_type (void)
{
	static volatile gsize custom_file_chooser_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&custom_file_chooser_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CustomFileChooserDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) custom_file_chooser_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CustomFileChooserDialog), 0, (GInstanceInitFunc) custom_file_chooser_dialog_instance_init, NULL };
		GType custom_file_chooser_dialog_type_id;
		custom_file_chooser_dialog_type_id = g_type_register_static (G_TYPE_OBJECT, "CustomFileChooserDialog", &g_define_type_info, 0);
		CustomFileChooserDialog_private_offset = g_type_add_instance_private (custom_file_chooser_dialog_type_id, sizeof (CustomFileChooserDialogPrivate));
		g_once_init_leave (&custom_file_chooser_dialog_type_id__volatile, custom_file_chooser_dialog_type_id);
	}
	return custom_file_chooser_dialog_type_id__volatile;
}



